
enum {
	Tstring,
	Tnumber,
	Ttrue,
	Tfalse,
	Tnull,
	Tmap,
	Tarray
};

typedef struct Jmap Jmap;
typedef struct Jarray Jarray;
typedef struct Jvalue Jvalue;

struct Jarray {
	Jvalue **base;
	int alloc;
	int used;
};

struct Jmap {
	char *name;
	Jvalue *value;
	Jmap *next;
};

struct Jvalue {
	int type;
	union {
		char *str;
		double num;
		int bool;
		Jarray *array;
		Jmap *map;
	};
};


extern void Jdump(int fd, Jvalue *o);
extern Jvalue *Jparse(int fd, char *file);
extern char *Jstrval(Jvalue *v, char *fmt, ...);
extern int Jnumval(Jvalue *v, char *fmt, ...);
extern Jmap *Jmapfirst(Jvalue *v, char *fmt, ...);
extern void Jfree(Jvalue *v);
